package com.vendor.burn.packagers.nand.ecc;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.packagers.nand.ecc.ECCBase;

public class ECC620 extends ECCBase {
  void ecc_data_gen(byte[] data, int len) {
    for (int i = 0; i < data.length; i++)
      data[i] = (byte)(data[i] ^ 0xFFFFFFFF); 
  }
  
  public int ecc_8bit_gen(byte[] data, int len, byte[] ecc_code) {
    ecc_data_gen(data, len);
    int ret = ecc_parity_gen(data, len * 8, 16, ecc_code);
    for (int i = 0; i < 28; i++)
      ecc_code[i] = (byte)(ecc_code[i] ^ 0xFFFFFFFF); 
    return ret;
  }
  
  public int ecc_13bit_gen(byte[] data, int len, byte[] ecc_code) {
    ecc_data_gen(data, len);
    int ret = ecc_parity_gen(data, len * 8, 13, ecc_code);
    for (int i = 0; i < 24; i++)
      ecc_code[i] = (byte)(ecc_code[i] ^ 0xFFFFFFFF); 
    return ret;
  }
  
  public int ecc_27bit1k_gen(byte[] data, int len, byte[] ecc_code) {
    ecc_data_gen(data, len);
    int ret = ecc_parity_gen(data, len * 8, 27, ecc_code);
    for (int i = 0; i < 48; i++)
      ecc_code[i] = (byte)(ecc_code[i] ^ 0xFFFFFFFF); 
    return ret;
  }
  
  public int ecc_41bit1k_gen(byte[] data, int len, byte[] ecc_code) {
    ecc_data_gen(data, len);
    int ret = ecc_parity_gen(data, len * 8, 41, ecc_code);
    for (int i = 0; i < 72; i++)
      ecc_code[i] = (byte)(ecc_code[i] ^ 0xFFFFFFFF); 
    return ret;
  }
  
  public int ecc_80bit1k_gen(byte[] data, int len, byte[] ecc_code) {
    ecc_data_gen(data, len);
    int ret = ecc_parity_gen(data, len * 8, 80, ecc_code);
    for (int i = 0; i < 140; i++)
      ecc_code[i] = (byte)(ecc_code[i] ^ 0xFFFFFFFF); 
    return ret;
  }
}
